pub mod unbias_rmm_gaussian_model;
pub mod australian;
pub mod phishing;
pub mod german;
pub mod mushrooms;

#[macro_export]
macro_rules! for_type {
  ($v:ident::<$($param:ty),*>, $body: block) => {
    $(for_type!{$v = $param, $body})*
  };
  ($v:ident::<$($param:ty,)*>, $body: block) => {
    $(for_type!{$v = $param, $body})*
  };
  ($v:ident = $param:ty, $body: block) => { {
     type $v = $param;
     {
       $body
     }
   } };
}

